/* The following code example is taken from the book
 * "The C++ Standard Library - A Tutorial and Reference, 2nd Edition"
 * by Nicolai M. Josuttis, Addison-Wesley, 2012
 *
 * (C) Copyright Nicolai M. Josuttis 2012.
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 */
#include "algostuff.hpp"
using namespace std;

bool bothEvenOrOdd (int elem1, int elem2)
{
    return elem1 % 2 == elem2 % 2;
}

int main()
{
    vector<int> coll1;
    list<int> coll2;
    deque<int> coll3;

    coll1 = { 1, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
    coll2 = { 1, 9, 8, 7, 6, 5, 4, 3, 2, 1 };
    coll3 = { 11, 12, 13, 19, 18, 17, 16, 15, 14, 11 };

    PRINT_ELEMENTS(coll1,"coll1: ");
    PRINT_ELEMENTS(coll2,"coll2: ");
    PRINT_ELEMENTS(coll3,"coll3: ");

    // sprawdź czy obie kolekcje zawierają te same elementy w dowolnym porządku
    if (is_permutation (coll1.cbegin(), coll1.cend(), // pierwszy zakres
                        coll2.cbegin())) {            // drugi zakres
        cout << "coll1 i coll2 zawierają te same elementy" << endl;
    }
    else {
        cout << "coll1 i coll2 zawierają różne elementy" << endl;
    }

    // sprawdź pozycje elementów parzystych i nieparzystych
    if (is_permutation (coll1.cbegin(), coll1.cend(), // pierwszy zakres
                        coll3.cbegin(),               // drugi zakres
                        bothEvenOrOdd)) {             // kryterium porównania
        cout << "elementy parzyste i nieparzyste pasują" << endl;
    }
    else {
        cout << "elementy parzyste i nieparzyste nie pasują" << endl;
    }
}
