/* The following code example is taken from the book
 * "The C++ Standard Library - A Tutorial and Reference, 2nd Edition"
 * by Nicolai M. Josuttis, Addison-Wesley, 2012
 *
 * (C) Copyright Nicolai M. Josuttis 2012.
 * Permission to copy, use, modify, sell and distribute this software
 * is granted provided this copyright notice appears in all copies.
 * This software is provided "as is" without express or implied
 * warranty, and with no claim as to its suitability for any purpose.
 */
#include <unordered_map>
#include <string>
#include <iostream>
using namespace std;

int main()
{
    // typ kontenera:
    // - unordered_map: elementy postaci par klucz-wartość
    // - string: klucze posiadają typ string
    // - float: wartosci posiadają typ float
    unordered_map<string,float> coll;

    // wstaw do kolekcji kilka elementow
    // z użyciem składni tablicy asocjacyjnej
    coll["VAT1"] = 0.23;
    coll["VAT2"] = 0.08;
    coll["Pi"] = 3.1415;
    coll["dowolna liczba"] = 4983.223;
    coll["Zero"] = 0;

    // zmień wartość
    coll["VAT1"] += 0.02;

    // wypisz różnicę w wartościach VAT
    cout << "różnica VAT: " << coll["VAT1"] - coll["VAT2"] << endl;
}
